/***********************************************
 *    Copyright (c) 2010 Valeriano Alfonso     *
 ***********************************************/
/*
	NOTA DE DOMINIO PUBLICO
	-----------------------
	ImgView es Dominio Publico. Esto significa que se puede hacer con el
	lo que se quiera sin haber ninguna garantia de reembolso o idoneidad.
	Se aprecia que la fuente sea citada.
*/


/*
	Historial de cambios
	--------------------
	1.0 2010-1-3 : Version inicial.

*/

/////////////////////////
// Configuracion
//
var imgview_prefix ;		// Se atoconfigura
var imgview_border = 10;	// Tambien ajustar en el CSS.




/////////////////////////////////////
// ImgView_Show
//

function ImgView_Show(obj){
	var elemFondo = document.getElementById('imgview_fondo');
	var elemImgview = document.getElementById('imgview');
	var elemImgCargando = document.getElementById('imgview_imgcargando');
	var elemEnlace = document.getElementById('imgview_enlace');
	var elemImg = document.getElementById('imgview_img');
	var preloader;
	var max_horiz, max_vert;
	var ventana_ancho, ventana_alto;
	var pagina_ancho, pagina_alto;
	var pos_horiz = 0, pos_vert = 0;


	// Obtener maximos de scroll
	if(window.innerHeight && window.scrollMaxY) {
		max_horiz = document.body.scrollWidth;
		max_vert = window.innerHeight + window.scrollMaxY;
	}else if(document.body.scrollHeight > document.body.offsetHeight){
		// all but Explorer Mac
		max_horiz = document.body.scrollWidth;
		max_vert = document.body.scrollHeight;
	}else{
		// Explorer Mac...would also work in Explorer 6 Strict, Mozilla and Safari
		max_horiz = document.body.offsetWidth;
		max_vert = document.body.offsetHeight;
	}

	// Obtener tamanho de la ventana
	if(window.innerHeight) {
		// Todos excepto Explorer
		ventana_ancho = window.innerWidth;
		ventana_alto = window.innerHeight;
	}else if(document.documentElement && document.documentElement.clientHeight){
		// Explorer 6 Strict
		ventana_ancho = document.documentElement.clientWidth;
		ventana_alto = document.documentElement.clientHeight;
	}else if(document.body){
		// Resto de Explorers
		ventana_ancho = document.body.clientWidth;
		ventana_alto = document.body.clientHeight;
	}

	// HACK: reducir el tamaho de ventana_ancho. Hace que no sobrepase los bordes
	ventana_ancho-=20;

	// Obtener el tamanho de la pagina
	if(max_vert < ventana_alto){
		pagina_alto = ventana_alto;
	}else{
		pagina_alto = max_vert;
	}
	if(max_horiz < ventana_ancho){
		pagina_ancho = ventana_ancho;
	}else{
		pagina_ancho = max_horiz;
	}

	// Obtener posicion del los scrolls
	if( typeof( window.pageYOffset ) == 'number' ) {
		// La mayoria de navegadores
		pos_vert = window.pageYOffset;
		pos_horiz = window.pageXOffset;
	} else if( document.body && ( document.body.scrollLeft || document.body.scrollTop ) ) {
		// Explorer
		pos_vert = document.body.scrollTop;
		pos_horiz = document.body.scrollLeft;
	} else if( document.documentElement && ( document.documentElement.scrollLeft || document.documentElement.scrollTop ) ) {
		// Explorer 6 Strict
		pos_vert = document.documentElement.scrollTop;
		pos_horiz = document.documentElement.scrollLeft;
	}



	// Centrar y hacer visible la imagen de cargando
	if(elemImgCargando){
		elemImgCargando.style.top =
			(pos_vert +
				((ventana_alto - elemImgCargando.height) / 2)) + 'px';
		elemImgCargando.style.left =
			(pos_horiz +
				((ventana_ancho - elemImgCargando.width) / 2)) + 'px';
		elemImgCargando.style.display = 'block';
	}

	// Hacer que el fondo ocupe la pagina y sea visible
	elemFondo.style.height = (pagina_alto + 'px');
	elemFondo.style.display = 'block';

	// Carga de la imagen
	preloader=new Image();
	preloader.onload=function(){

		// Mostrar imgview, necesario para que los tamanhos sean correctos
		elemImgview.style.display = 'block';

		// Establecer la imagen precargada
		elemImg.src = obj.href;
		elemImg.width = preloader.width;
		elemImg.height = preloader.height;

		// Ajustar el tamanho de la imagen
		var relacion=elemImg.width/elemImg.height;
		if((elemImg.height+imgview_border*2)>ventana_alto){
			elemImg.height=ventana_alto-imgview_border*2;
			elemImg.width=elemImg.height*relacion;
		}
		if((elemImg.width+imgview_border*2)>ventana_ancho){
			elemImg.width=ventana_ancho-imgview_border*2;
			elemImg.height=elemImg.width/relacion;
		}

		// Centrar imgview
		elemImgview.style.top =
			(pos_vert +
				((ventana_alto - elemImg.height) / 2) - imgview_border) + 'px';
		elemImgview.style.left =
			(pos_horiz +
				((ventana_ancho - elemImg.width) / 2) - imgview_border) + 'px';


		// Oclultar imagen de cargar y mostrar imgview
		if(elemImgCargando) {
			elemImgCargando.style.display = 'none';
		}

		return false;
	}
	preloader.src = obj.href;
	elemEnlace.href = obj.href;
}








/////////////////////////////////////
// ImgView_Hide
//
function ImgView_Hide(){
	var elemFondo = document.getElementById('imgview_fondo');
	var elemImgview = document.getElementById('imgview');
	elemFondo.style.display = 'none';
	elemImgview.style.display = 'none';
}











/////////////////////////////////////
// ImgView_Init
//
// Asociar al evento "onclick" la funcion "ImgView_Show" a los links con rel="imgview".
// Anhadir el markup necesario para mostrar imagenes.
function ImgView_Init(){
	var i;
	var enlaces;

	if (!document.getElementsByTagName){
		return;
	}

	// HACK: Obtener el path donde de este mismo script
	enlaces=document.getElementsByTagName("head")[0].getElementsByTagName("script");
	var imgview_RegExp = /imgview\.js/i;
	for(i=0;i<enlaces.length;i++){
		if(imgview_RegExp.test(enlaces[i].getAttribute("src"))){
			imgview_prefix=enlaces[i].getAttribute("src").
				replace(imgview_RegExp,"");
		}
	}



	// Iterar los enlaces
	enlaces = document.getElementsByTagName("a");
	for(i=0;i<enlaces.length;i++){
		if(enlaces[i].getAttribute("href") &&
			(enlaces[i].getAttribute("rel") == "imgview"))
		{
			enlaces[i].onclick =
				function () {
					ImgView_Show(this);
					return false;
				}
		}
	}

	// Inyectar el link de la hoja de estilo
	var LinkHoja=document.createElement('link');
	LinkHoja.rel='stylesheet';
	LinkHoja.href=imgview_prefix+"/imgview.css";
	document.getElementsByTagName("head")[0].appendChild(LinkHoja);


	// Inyectar markup del fondo con la animacion de carga
	var elemCuerpo = document.body;
	var elemFondo = document.createElement("div");
	elemFondo.setAttribute('id','imgview_fondo');
	elemFondo.onclick =
		function () {
			ImgView_Hide();
			return false;
		}
	elemFondo.style.display = 'none';
	elemFondo.style.position = 'absolute';
	elemFondo.style.top = '0';
	elemFondo.style.left = '0';
	elemFondo.style.zIndex = '90';
 	elemFondo.style.width = '100%';
	elemCuerpo.insertBefore(elemFondo, elemCuerpo.firstChild);
	var elemEnlaceCargando = document.createElement("a");
	elemEnlaceCargando.setAttribute('href','#');
	elemEnlaceCargando.setAttribute('title','Click para cerrar');
	elemEnlaceCargando.onclick =
		function () {
			ImgView_Hide();
			return false;
		}
	elemFondo.appendChild(elemEnlaceCargando);
	var elemImgCargando = document.createElement("img");
	elemImgCargando.src = imgview_prefix+"/cargando.gif";
	elemImgCargando.setAttribute('id','imgview_imgcargando');
	elemImgCargando.style.position = 'absolute';
	elemImgCargando.style.zIndex = '150';
	elemEnlaceCargando.appendChild(elemImgCargando);

	// Inyectar markup de imgview
	var elemImgview = document.createElement("div");
	elemImgview.setAttribute('id','imgview');
	elemImgview.style.display = 'none';
	elemImgview.style.position = 'absolute';
	elemImgview.style.zIndex = '100';
	elemCuerpo.insertBefore(elemImgview, elemFondo.nextSibling);
	var elemEnlace = document.createElement("a");
	elemEnlace.setAttribute('href','#');
	elemEnlace.setAttribute('id','imgview_enlace');
	elemEnlace.setAttribute('title','Click para cerrar');
	elemEnlace.onclick =
		function () {
			ImgView_Hide();
			return false;
		}
	elemImgview.appendChild(elemEnlace);
	var elemImg = document.createElement("img");
	elemImg.setAttribute('id','imgview_img');
	elemEnlace.appendChild(elemImg);
}







// Asociar la funcion de inciado al evento "onload"
// sin evitar la ejecucion de lo que pudiera estar antes
var imgview_oldonload = window.onload;
if (typeof(imgview_oldonload)!='function'){
	window.onload = ImgView_Init;
}else{
	window.onload = function(){
		imgview_oldonload();
		ImgView_Init();
	}
}

//alert(window.location.pathname);
//alert(document.URL);
//alert(location.codeBase);